* Extended Superbasic interface for the DATAdesign.engine thing
* uitgebreide en volledig geteste versie
* (c) Sep 1991 by Joachim Van der Auwera ;for PROGS
* aangepast voor v3.+ van engine Aug 1992 to Jan 1993
        section interfac
*
        include win1_dd_src_engine_aid_mac
        include win1_dd_src_engine_struct_h
        include win1_inc_keys_ext_thg
        include win1_inc_qdos_sms
        include win1_inc_keys_qlv
        include win1_inc_keys_err
        include win1_inc_qdos_io
        include win1_inc_wman_keys
*
thh_code equ    $18
bv_rip   equ    $58
bv.chrix equ    $11a
bv_chbas equ    $30
bv_chp   equ    $34
ch.lench equ    $28

blen    equ     604
rets    equ     88
*
        xdef    start
        xref    dde_use,dde_free
*
linkmess
        dc.w    endmess-*-2
        dc.b    'DATAdesign SuperBASIC interface installed',10
        dc.b    '(c) 1991/92/93 PROGS',10
endmess
        ds.w    0               ; make address even !!!
*
****************************************************************************
*
* v2.00 initial version, eerste versie met volledige parameteraanvaarding
* v2.01 SORTfile now accepts 10 sort levels
* v2.02 fileid en veldnr is nu voor elke job verschillend
* v3.00 aangepast voor v3.+ van engine
*       o.a. nu automatisch dd_err steeds updaten met error waarde
*       some WMAN routines to edit strings added
*
****************************************************************************
start
        lea     linkmess(pc),a1 ; message
        sub.l   a0,a0           ; to channel 0
        move.w  ut.wtext,a2
        jsr     (a2)

        move.w  bi.inipr,a0
        lea     procs(pc),a1
        jmp     (a0)            ; link new SuperBASIC command

nam     macro   n,p
        dc.w    [p]-*
        dc.b    [.len(n)]
        dc.b    '[n]'
        endm

procs   dc.w    90              ; 'nr' of procedures
        nam     ADDfield,addfield
        nam     BACKfile,back
        nam     CLEARmark,cmrk
        nam     DEFbuffer,defb
        nam     DEFfield,deff
        nam     DEFindex,defi
        nam     DELrec,dele
        nam     DUPLICATE,dupl
        nam     EDITstring,enam
        nam     fieldCLEAR,fldc
        nam     fieldDELETE,fldd
        nam     fieldRENAME,fldr
        nam     FILTER,filt
        nam     FINDfloat,fndd
        nam     FINDinteger,fndi
        nam     FINDstring,fnds
        nam     FIRSTrec,frst
        nam     GARBAGE,garb
        nam     GETdouble,gdbl
        nam     GETfilter,gifl
        nam     GETrec,grec
        nam     GETsort,gisl
        nam     IMPLEMENT,impl
        nam     indexDELETE,idel
        nam     indexIMPLEMENT,iimp
        nam     indexLOAD,iloa
        nam     indexREMOVE,irmv
        nam     indexSAVE,isav
        nam     indexUPDATE,iupd
        nam     INSERTel,inse
        nam     LASTrec,last
        nam     NEWfile,newfile
        nam     NEWrec,newrec
        nam     NEXTrec,next
        nam     PREVrec,prev
        nam     READstring,rnam
        nam     REMOVEel,rmve
        nam     SAVEfile,save
        nam     SAVEfinish,savf
        nam     SAVEinit,savi
        nam     SAVErec,savr
        nam     SETchar,schr
        nam     SETdouble,sdbl
        nam     SETfield,sfld
        nam     SETFILEstatus,sfst
        nam     SETfilter,sifl
        nam     SETfloat,sfloat
        nam     SETline,sstr
        nam     SETlong,slng
        nam     SETmark,smrk
        nam     SETshort,sshr
        nam     SETsort,sisl
        nam     SETVIEWstatus,svst
        nam     SET_IRS,setirs
        nam     SORTfile,sort
        nam     UNUSEbuffer,unus
        nam     USEfile,use
        dc.w    0,50            ; end of procedures + 'nr' of functions
        nam     bufferID,idbf
        nam     COUNTall,countall
        nam     COUNTrec,countrec
        nam     CYCLEbuffer,cycb
        nam     CYCLEfield$,cycf
        nam     CYCLEfile$,cycl
        nam     fieldID,fieldid
        nam     fieldLEN,lenf
        nam     fieldNAME$,fieldname
        nam     fieldTYPE,fieldtype
        nam     FILEdevice$,filedevice
        nam     FILEname$,filename
        nam     FILEstatus,gfst
        nam     GETchar$,gchr
        nam     GETfield,gfld
        nam     GETfloat,gfloat
        nam     GETline$,gstr
        nam     GETlong,glng
        nam     GETmark,gmrk
        nam     GETshort,gshr
        nam     GET_IRS,getirs
        nam     indexFIND,ifnd
        nam     indexID,idin
        nam     lineLEN,lens
        nam     NRfields,nrfields
        nam     NRlines,nrln
        nam     recordDATE,date
        nam     recordID,recordid
        nam     recordLEN,lenr
        nam     VIEWstatus,gvst
        dc.w    0               ; end of functions

*** some general, handy routines
; get a bufferid or indexid, has to be preceded by a hash (#), and has to be a float
* ptr to superbasic parameter in a3
* ptr to extension  parameter in a1
get_bid
        cmpa.l  a3,a5           ; is there a param
        beq.s   def_bid         ; no -> default
        move.w  0(a6,a3.l),d2
        btst    #7,d2           ; preceded by a hash
        beq.s   def_bid         ; no -> forget about this one
        move.l  #thp.ulng<<16,(a1)+ ; fill in type of parameter
        andi.b  #3,d2           ; only type
        cmpi.b  #2,d2           ; float ?
        bne     err_ipar
        bra     lint_           ; fill in the parameter
def_bid clr.l   (a1)+           ; neen -> 0 (default)
        clr.l   (a1)+           ; provide 0 as parameter
        rts

; return a long integer to SuperBASIC, value in d7
return
        moveq   #6,d1           ;we will need 6 bytes on the arithmetic stack
        move.w  bv.chrix,a0
        jsr     (a0)            ;bv.chrix, reserve space on arithmetic stack
        move.l  bv_rip(a6),a1   ; offset of arithmetic stack
        subq.l  #6,a1
        move.l  a1,bv_rip(a6)
        clr.w   d3
        clr.w   d1
        move.l  d7,d2           ; value to convert
        beq.s   setret
        bpl.s   retpos

        moveq   #1,d3
        neg.l   d2
retpos
        move.w  #$81f,d1        ; convert long integer to fp
loop    rol.l   #1,d2
        bmi.s   endlp
        subq.w  #1,d1
        bra.s   loop

endlp   ror.l   #1,d2
        tst.w   d3
        beq.s   setret
        neg.l   d2

setret  move.w  d1,0(a6,a1.l)   ; set return value on arithmetic stack
setret2 move.l  d2,2(a6,a1.l)
        moveq   #2,d4           ; float
        moveq   #0,d0
exit    rts

; return a double to SuperBASIC, value in pointed in a5
; returned as standard qlfloat
retdbl
        moveq   #6,d1           ;we will need 6 bytes on the arithmetic stack
        move.w  bv.chrix,a0
        jsr     (a0)            ;bv.chrix, reserve space on arithmetic stack
        move.l  bv_rip(a6),a1   ; offset of arithmetic stack
        subq.l  #6,a1
        move.l  a1,bv_rip(a6)
        ; convert double to qlfloat
        move.l  (a5)+,d0
        move.l  (a5)+,d1
        moveq   #0,d3
        lsl.l   #1,d0           ; clear sign bit
        roxl.l  #1,d3           ; and put it in d3
        lsr.l   #1,d0
        bne.s   dbl0
        tst.l   d1              ; is the value 0 ??
        bne.s   dbl0
        moveq   #0,d2
        bra.s   dbl1
dbl0    move.l  d0,d2
        move.w  #20,d4
        lsr.l   d4,d0
        add.w   #$402,d0
        and.l   #$fffff,d2
        or.l    #$100000,d2
dbl1    move.w  d0,0(a6,a1.l)
        move.w  #10,d0
        lsl.l   d0,d2
        move.w  #22,d0
        lsr.l   d0,d1
        or.l    d1,d2
dbl2    tst.b   d3
        beq     setret2
        neg.l   d2
        bra     setret2


; return a string to SuperBASIC, string in a5
retstr  moveq   #3,d1
        add.w   (a5),d1         ; nr of bytes we need on arithmetic stack
        andi.w  #$fffe,d1
        move.w  d1,d7
        move.w  bv.chrix,a0
        jsr     (a0)            ; bv.chrix, reserve space on arithmetic stack

        move.l  bv_rip(a6),a1   ; offset of arithmetic stack
        suba.w  d7,a1
        move.l  a1,bv_rip(a6)
        move.w  (a5)+,d1        ; length of string
        move.w  d1,0(a6,a1.l)   ; put in
        subq.w  #1,d1           ; adjust to dbf
        bmi.s   fldn_set
fldn_cp move.b  (a5)+,2(a6,a1.l) ;copy next character
        addq.l  #1,a1
        dbf     d1,fldn_cp
fldn_set
        moveq   #1,d4           ; STRING
        bra     relmem          ; and release mem for passing of vars

* routine to get the fieldnr as a parameter
* ptr to superbasic parameter in a3
* ptr to end of parameters in a5
* ptr to extension parameter in a1
* start of memory in a4
get_fld cmpa.l  a3,a5           ; explicit parameter
        beq.s   cf              ; neen -> take current field
        move.w  0(a6,a3.l),d1
        andi.w  #3,d1           ; empty parameter
        bne.s   get_fld2        ; no -> read parameter
        addq.l  #8,a3
cf      move.l  #-1,(a1)+       ; take default field
        moveq   #0,d0
        rts
get_fld2
        cmpi.b  #1,d1           ; passed as a string ?
        bne     get_sint        ; no -> get short integer
        ; ok so we have to get the fieldid for this one
        move.l  a1,d4
        move.l  a2,d5
        lea     blen-40(a4),a1
        move.l  (a4),(a1)+
        move.l  4(a4),(a1)+
        bsr     get_str
        lea     blen-4(a4),a2
        move.w  #thp.ret+thp.uwrd,(a1)+ ; fill in place for return
        clr.w   (a1)+
        move.l  a2,(a1)+
        clr.w   (a2)+
        move.l  #'IDFI',d2      ; name of extension to use
        jsr     dde_use(pc)     ; use thing
        bne     exit            ; you're kidding
        move.l  a1,a0           ; copy ptr to thing
        lea     blen-40(a4),a1  ; ptr to parameters
        jsr     thh_code(a0)    ; execute thing
        move.l  d0,d7           ; error code
        jsr     dde_free(pc)    ; free_thing
        move.l  d7,d0
        bmi     exit
        moveq   #0,d7
        move.w  blen-4(a4),d7
        move.l  d4,a1           ; restore param place
        move.l  d5,a2
        move.l  d7,(a1)+        ; and fill in field id
        rts

* routine to get an optional short integer parameter, or -1
* ptr to superbasic parameter in a3
* ptr to end of parameters in a5
* ptr to extension  parameter in a1
get_oi  cmpa.l  a3,a5           ; explicit parameter
        beq.s   c1              ; neen -> take current field
        move.w  0(a6,a3.l),d1
        andi.b  #3,d1           ; empty parameter
        bne     get_sint        ; no -> read parameter
        addq.l  #8,a3
c1      move.l  #-1,(a1)+       ; take current field
        rts

get_oi0 cmpa.l  a3,a5           ; explicit parameter
        beq.s   c2              ; neen -> take current field
        move.w  0(a6,a3.l),d1
        andi.b  #3,d1           ; empty parameter
        bne     get_sint        ; no -> read parameter
        addq.l  #8,a3
c2      move.l  #0,(a1)+        ; take 0 as default
        rts

get_oi2 cmpa.l  a3,a5           ; explicit parameter
        beq.s   c3              ; neen -> take current field
        move.w  0(a6,a3.l),d1
        andi.b  #3,d1           ; empty parameter
        bne.s   get_sint        ; no -> read parameter
        addq.l  #8,a3
c3      move.l  #2,(a1)+        ; take 0 as default
        rts

get_oi1 cmpa.l  a3,a5           ; explicit parameter
        beq.s   c4              ; neen -> take current field
        move.w  0(a6,a3.l),d1
        andi.b  #3,d1           ; empty parameter
        bne.s   get_sint        ; no -> read parameter
        addq.l  #8,a3
c4      move.l  #1,(a1)+        ; take 0 as default
        rts

* ptr to superbasic parameter in a3
* ptr to extension  parameter in a1
get_lint
        cmpa.l  a3,a5
        beq.s   err_ipar
        move.w  0(a6,a3.l),d2
        andi.b  #3,d2           ; only type
lsint   cmpi.b  #2,d2           ; float ?
        bne.s   err_ipar

lint_   cmpi.w  #2,d2           ; waarde bepaald ?
        bne.s   lint__          ; ja -> halen
        clr.l   (a1)+           ; neen -> 0
        addq.l  #8,a3
        rts

lint__  move.l  $28(a6),d1      ; offset of value list
        add.l   4(a6,a3.l),d1
        cmpi.w  #$302,d2        ; array ??
        bne.s   noalng
        move.l  0(a6,d1.l),d1
        add.l   $28(a6),d1
noalng  move.w  0(a6,d1.l),d2   ; exponent
        move.l  2(a6,d1.l),d1   ; mantissa
        subi.w  #$800,d2
        neg.w   d2
        addi.w  #31,d2
        asr.l   d2,d1           ;long word
        move.l  d1,(a1)+
        addq.l  #8,a3
        moveq   #0,d0
        rts

err_orng
        moveq   #err.orng,d0
        bra.s   oops
err_ipar
        moveq   #err.ipar,d0
oops    addq.l  #4,sp
        rts                     ; error BAD PARAMETER

* ptr to superbasic parameter in a3
* ptr to extension  parameter in a1
get_sint
        cmpa.l  a3,a5
        beq     err_ipar
        move.w  0(a6,a3.l),d2
        andi.b  #3,d2           ; only type
        cmpi.b  #3,d2           ; integer ?
        bne.s   lsint

        moveq   #0,d1
        cmpi.w  #3,d2           ; undefined ?
        beq.s   nosg

        move.l  $28(a6),d1      ; offset of value list
        add.l   4(a6,a3.l),d1
        cmpi.w  #$303,d2        ; array ??
        bne.s   noasi
        move.l  0(a6,d1.l),d1
        add.l   $28(a6),d1
noasi   move.w  0(a6,d1.l),d1   ; integer
        andi.l  #$0000ffff,d1   ; long word van maken
nosg    move.l  d1,(a1)+
        addq.l  #8,a3
        moveq   #0,d0
        rts

* ptr to superbasic parameter in a3
* ptr to extension  parameter in a1
get_cmp moveq   #0,d7
        cmpa.l  a3,a5
        beq.s   n_cmp
        move.w  0(a6,a3.l),d2
        andi.b  #3,d2           ; only type
        beq.s   e_cmp           ; if empty parameter -> clear
        cmpi.b  #1,d2           ; string ?
        bne.s   get_sint        ; no -> get compare value

        move.l  $28(a6),d1      ; offset of value list
        add.l   4(a6,a3.l),d1
        cmpi.w  #$301,d2        ; array ??
        bne.s   noacmp
        move.l  0(a6,d1.l),d1
        add.l   $28(a6),d1
noacmp  move.w  0(a6,d1.l),d2   ; nr of letters to copy
        subq.w  #1,d2           ; aanpassen dbf
        bmi.s   e_cmp
chrlp   move.b  2(a6,d1.l),d5   ; char in cmp string
        addq.l  #1,d1
        lea     cmpcode(pc),a0
cmplp   move.b  (a0)+,d6
        bmi.s   ncl
        cmp.b   (a0)+,d5
        bne.s   cmplp
        bset    d6,d7
        bra.s   cmplp
ncl     dbf     d2,chrlp
e_cmp   addq.l  #8,a3
n_cmp   move.l  d7,(a1)+
        rts

cmpcode
        dc.b    c..mark,'m',c..mark,'M'
        dc.b    c..agai,'a',c..agai,'A'
        dc.b    c..line,'l',c..line,'L'
        dc.b    c..case,'c',c..case,'C'
        dc.b    c..rvrs,'-',c..rvrs,'r',c..rvrs,'R'
        dc.b    c..text,'t',c..text,'T'
        dc.b    c..and,'&'
        dc.b    c..equ,'=',c..smal,'<',c..larg,'>'
        dc.b    c..empty,'e',c..empty,'E'
        dc.b    c..str,'s',c..str,'S'
        dc.w    -1

* ptr to superbasic parameter in a3
* ptr to extension  parameter in a1
get_char
        cmpa.l  a3,a5
        beq     err_ipar
        move.w  0(a6,a3.l),d2
        andi.b  #3,d2           ; only type
        cmpi.b  #1,d2           ; string ?
        bne     get_sint

        move.l  $28(a6),d1      ; offset of value list
        add.l   4(a6,a3.l),d1
        cmpi.w  #$301,d2        ; array ??
        bne.s   noachr
        move.l  0(a6,d1.l),d1
        add.l   $28(a6),d1
noachr  moveq   #0,d2
        move.b  2(a6,d1.l),d2   ; character we need
        move.l  d2,(a1)+        ; fill in value
        addq.l  #8,a3
        rts

* ptr to superbasic parameter in a3
* ptr to extension  parameter in a1
* ptr to place to put string in a2
get_str
        cmpa.l  a3,a5
        beq.s   nopstr
        move.w  0(a6,a3.l),d2
        andi.b  #3,d2           ; only type
        beq.s   nostr
        cmpi.b  #1,d2           ; string ?
        bne     err_ipar

        moveq   #0,d3
        move.l  4(a6,a3.l),d1   ; value pointer
        bmi.s   nodstr          ; oops, string undefined
        add.l   $28(a6),d1      ; offset of value list
        cmpi.w  #$301,d2        ; was this an array type ??
        bne.s   noastr
        move.l  0(a6,d1.l),d1
        add.l   $28(a6),d1      ; offset of value list
noastr  move.w  0(a6,d1.l),d3   ; nr of letters to copy
nodstr  cmpi.w  #256,d3         ; we can't handle strings longer than this
        bgt     err_orng
        move.w  #thp.str+thp.ptr,(a1)+
        clr.w   (a1)+
        move.l  a2,(a1)+        ; fill in ptr to string
        move.w  d3,(a2)+        ; length of string
        beq.s   emstr
        or.w    #1,d3           ; make sure even address after copying
strg_cp move.b  2(a6,d1.l),(a2)+ ;copy character
        addq.l  #1,d1
        dbf     d3,strg_cp      ; copy next byte
emstr   addq.l  #8,a3
        rts
nostr   addq.l  #8,a3
nopstr  clr.l   (a1)+
        clr.l   (a1)+
        rts

* ptr to superbasic parameter in a3
* ptr to extension  parameter in a1
* ptr to place to put string in a2
get_txt8                ; get 8 chars
        cmpa.l  a3,a5
        beq.s   nopstr
        move.w  0(a6,a3.l),d2
        andi.b  #3,d2           ; only type
        beq.s   nostr
        cmpi.b  #1,d2           ; string ?
        bne     err_ipar

        clr.l   (a1)
        clr.l   4(a1)
        move.l  4(a6,a3.l),d1   ; place in value list
        cmpi.l  #-1,d1          ; undefined ??
        bmi.s   ntxt8           ; -> done
        add.l   $28(a6),d1      ; offset of value list
        cmpi.w  #$301,d2        ; was this an array type ??
        bne.s   noatxt8
        move.l  0(a6,d1.l),d1
        add.l   $28(a6),d1      ; offset of value list
noatxt8 move.w  0(a6,d1.l),d2   ; nr of letters to copy
        cmpi.w  #8,d2           ; max 8
        bmi.s   txtm8
        moveq   #8,d2
txtm8   subq.w  #1,d2           ; adjust for dbf
        bmi.s   ntxt8
        move.l  a1,d3
txt8_cp move.b  2(a6,d1.l),(a1)+; copy character
        addq.l  #1,d1
        dbf     d2,txt8_cp      ; copy next byte
        move.l  d3,a1
ntxt8   addq.l  #8,a3
        addq.l  #8,a1
        rts

* ptr to superbasic parameter in a3
* ptr to extension  parameter in a1
* get a double passed as a float
get_qldbl
        move.w  0(a6,a3.l),d1
        andi.b  #3,d1           ; only type
        cmpi.b  #2,d1           ; float ?
        bne     err_ipar
        cmpi.w  #2,d1           ; waarde bepaald ?
        bne.s   qldbl           ; ja -> halen
nodbl   clr.l   (a1)+           ; neen -> 0
        clr.l   (a1)+
        addq.l  #8,a3
        rts
qldbl   move.l  $28(a6),d1      ; offset of value list
        add.l   4(a6,a3.l),d1
        moveq   #0,d2
        move.w  0(a6,d1.l),d2   ; exponent
        move.l  2(a6,d1.l),d0   ; mantissa
        tst.w   d2
        bne.s   gotdbl
        tst.l   d0
        beq.s   nodbl
gotdbl  sub.w   #$402,d2        ; correct exponent
        swap    d2
        lsl.l   #4,d2           ; put is completely left
        btst    #31,d0
        beq.s   dblpos
        neg.l   d0
        bset    #31,d2
    btst.l  #30,d0
    bne     dblpos
    add.l   #$100000,d2     ; increase exponent value by 1
dblpos  lsl.l   #2,d0           ; sign + implicit bit wegshiften in mantissa
        moveq   #0,d1
        move.w  d0,d1
        moveq   #12,d3
        lsr.l   d3,d0
        or.l    d2,d0
        swap    d1
        lsl.l   #4,d1
        move.l  d0,(a1)+        ; fill in double
        move.l  d1,(a1)+
        addq.l  #8,a3
        moveq   #0,d0
        rts

* ptr to superbasic parameter in a3
* ptr to extension  parameter in a1
* get a double passed as a ptr to a double
get_pdbl
        move.l  (sp)+,d5        ; keep ret address
        bsr     get_lint        ; get address
        move.l  d5,-(sp)        ; restore ret address
        move.l  -(a1),d1        ; get addres of double
        beq     nodbl           ; not passed -> take zero
        btst    #0,d1           ; is this a valid addres ??
        bne.s   nodbl           ; no -> take zero
        move.l  d1,a0
        move.l  (a0)+,(a1)+
        move.l  (a0)+,(a1)+
        rts

* routines to initialise the command
getmem  move.l  a3,-(sp)
        move.l  #blen+8,d1      ; we want 600 bytes for the parameter parsing
        moveq   #sms.myjb,d2    ; for the calling job
        moveq   #sms.achp,d0    ; reserve it
        trap    #do.sms2
        move.l  (sp)+,a3
        tst.l   d0
        bmi     oops            ; report error
        move.l  a0,a4           ; keep it
        move.l  a0,a1           ; place to fill in pars
        lea     rets(a0),a2     ; start for strings and return pars

        move.l  a5,d7
        sub.l   a3,d7
        lsr.l   #3,d7           ; nr of parameters
        rts

relmem  move.l  a4,a0           ; start of area
        moveq   #sms.rchp,d0    ; release it
        trap    #do.sms2
        moveq   #0,d0
        rts

; update parameter (long or float) to value in d7, ptr in a3 (entry)
update  move.w  0(a6,a3.l),d1
        andi.b  #3,d1           ; only type
        cmpi.b  #3,d1           ; integer ?
        beq.s   updint          ; yep -> ..
        moveq   #6,d1           ; we will need 6 bytes on the arithmetic stack
        move.w  bv.chrix,a0
        jsr     (a0)            ; bv.chrix, reserve space on arithmetic stack

        move.l  bv_rip(a6),a1   ; offset of arithmetic stack
        subq.l  #6,a1
        move.l  a1,bv_rip(a6)
        clr.w   d3
        clr.w   d1
        move.l  d7,d2           ; value to convert
        beq.s   sret
        bpl.s   rpos

        moveq   #1,d3
        neg.l   d2
rpos
        move.w  #$81f,d1        ; convert long integer to fp
lop     rol.l   #1,d2
        bmi.s   endlop
        subq.w  #1,d1
        bra.s   lop

endlop  ror.l   #1,d2
        tst.w   d3
        beq.s   sret
        neg.l   d2

sret    move.w  d1,0(a6,a1.l)   ; set return value on arithmetic stack
        move.l  d2,2(a6,a1.l)

        move.w  bi.sprm,a2
        jmp     (a2)            ; set value in name table and return

updint  moveq   #2,d1           ; we will need 2 bytes on the arithmetic stack
        move.w  bv.chrix,a0
        jsr     (a0)            ; bv.chrix, reserve space on arithmetic stack

        move.l  bv_rip(a6),a1   ; offset of arithmetic stack
        subq.l  #2,a1
        move.l  a1,bv_rip(a6)

        move.w  d7,0(a6,a1.l)   ; set return value on arithmetic stack

        move.w  bi.sprm,a2
        jmp     (a2)            ; set value in name table and return

; routine on variabele dd_err te zetten naar de error code in d0
; case dependant !!
seterr  subr
        regsave d1/d2/a1-a3
bv_ntbas equ    $18
bv_ntp   equ    $1c
bv_nlbas equ    $20
bv_nlp   equ    $24
bv_vvbas equ    $28
        move.l  bv_nlbas(a6),a1
        move.l  bv_nlp(a6),d2
        ; first search for the name in the name list
errlp   cmp.l   d2,a1
        bpl.s   errend
        cmpi.b  #6,0(a6,a1.l)
        bne.s   errnxt
        cmpi.b  #'_',3(a6,a1.l)
        bne.s   errnxt
        cmpi.b  #'r',6(a6,a1.l)
        bne.s   errnxt
        cmpi.b  #'r',5(a6,a1.l)
        bne.s   errnxt
        cmpi.b  #'e',4(a6,a1.l)
        bne.s   errnxt
        cmpi.b  #'d',2(a6,a1.l)
        bne.s   errnxt
        cmpi.b  #'d',1(a6,a1.l)
        bne.s   errnxt
        ; yes we found it, now fill in the new value
        move.l  a1,d1
        sub.l   bv_nlbas(a6),d1
        move.l  bv_ntbas(a6),a3
        move.l  bv_ntp(a6),d2
errlp2  cmp.l   d2,a3
        bpl.s   errend
        cmp.w   2(a6,a3.l),d1
        beq.s   errset
        addq.l  #8,a3
        bra.s   errlp2
errset  move.l  d0,d7
        bsr     update
        bra.s   errend
errnxt  moveq   #0,d1
        move.b  0(a6,a1.l),d1
        lea     1(a1,d1.w),a1
        bra.s   errlp
errend  subend


************ macros to write easy commands ************
init    macro                   ; initialise command
[.lab]  bsr     getmem
        endm

exit    macro                   ; terminate command
[.lab]  bra     relmem
        endm

return  macro                   ; return the value in d7 (long -> float)
[.lab]  bsr     relmem
        bra     return
        endm

retfloat macro                  ; return a qlfloat as double in a5
        bsr     relmem
        bra     retdbl
        endm

do      macro   name            ; execute an extension
        move.l  [name],d2       ; name of extension to use
        jsr     dde_use(pc)     ; use thing
        bne     exit            ; you're kidding
        move.l  a1,a0           ; copy ptr to thing
        move.l  a4,a1           ; ptr to parameters
        jsr     thh_code(a0)    ; execute thing
        move.l  d0,d7
        bsr     seterr          ; set dd_err to the error code
        jsr     dde_free(pc)    ; free_thing
        endm

string  macro                   ; get a (optional) string
        bsr     get_str
        endm

retlong macro                   ; initialise long return
[.lab]  move.w  #thp.ret+thp.ulng,(a1)+
        clr.w   (a1)+
        move.l  a2,(a1)+
        clr.l   (a2)+
        endm

retshort macro                  ; initialise short return
        move.w  #thp.ret+thp.uwrd,(a1)+
        clr.w   (a1)+
        move.l  a2,(a1)+
        clr.w   (a2)+
        endm

retstrg macro                   ; initialise long return
        move.w  #thp.ret+thp.str,(a1)+
        move.w  #254,(a1)+
        move.l  a2,(a1)+
        lea     256(a2),a2
        endm

retdbl  macro                   ; initialise double return
        move.w  #thp.ret+thp.fp8,(a1)+
        clr.w   (a1)+
        move.l  a2,(a1)+
        clr.l   (a2)+
        clr.l   (a2)+
        endm

bid     macro                   ; get a buffer id
        bsr     get_bid
        endm

field   macro                   ; get a fieldid, can be passed as a fieldname
        bsr     get_fld
        bmi     exit            ; error -> ..
        endm

long    macro                   ; get (explicit) long integer parameter
        bsr     get_lint
        endm

short   macro                   ; get explicit short integer parameter
        bsr     get_sint
        endm

oshort  macro                   ; get optional short parameter
        bsr     get_oi
        endm

oshort0 macro                   ; get optional short parameter (default=0)
        bsr     get_oi0
        endm

oshort1 macro                   ; get optional short parameter (default=1)
        bsr     get_oi1
        endm

oshort2 macro                   ; get optional short parameter (default=2)
        bsr     get_oi2
        endm

char    macro                   ; get char as parameter
        bsr     get_char
        endm

ushort  macro                   ; get word which can be updated
        move.w  #thp.upd+thp.uwrd,(a1)+
        clr.w   (a1)+
        addq.l  #2,a2
        move.l  a2,(a1)+
        subq.l  #2,a2
        exg     a1,a2
        bsr     get_sint
        exg     a1,a2
        endm

qldbl   macro                   ; get a double, passed as QLFLOAT
        bsr     get_qldbl
        endm

double  macro                   ; get a double, passed as ptr to
        bsr     get_pdbl
        endm

compare macro                   ; get a compare string or value
[.lab]  bsr     get_cmp
        endm

********** start of the actual routines ********
; all routines put the error returned by the DATAdesign engine in "dd_err"
; this variable has to be initialised beforehand,
; case is important when typing the variable name !!

newfile init
        string
        retlong
        move.l  #'NEWF',d6
exitdo
        do      d6
        exit

recordid move.l #'IDRE',d6
        bra.s   lret
countall move.l #'CNTA',d6
        bra.s   lret
countrec move.l #'CNTR',d6
        bra.s   lret
idin    move.l  #'IDIN',d6
        bra.s   lret
date    move.l  #'DATE',d6
        bra.s   lret
lenr    move.l  #'LENR',d6
        bra.s   lret
cycb    move.l  #'CYCB',d6
lret    init
        bid
rlong
        retlong
        do      d6
        move.l  rets(a4),d7
        return

gvst    move.l  #'GVST',d6
        bra.s   rsh
gfst    move.l  #'GFST',d6
        bra.s   rsh
getirs  move.l  #'GIRS',d6
        bra.s   rsh
nrfields move.l #'CNTF',d6
rsh     init
        bid
rshort
        retshort
        do      d6
        moveq   #0,d7
        move.w  rets(a4),d7
        ext.l   d7
        return

addfield init
        bid
        string
        oshort2
        move.l  #'ADDF',d6
        bra     exitdo

fieldid init
        bid
        string
        lea     rets+256(a4),a2
        retshort
        do      #'IDFI'
        moveq   #0,d7
        move.w  rets+256(a4),d7
        return

fieldtype init
        bid
        field
        move.l  #'FLDT',d6
        bra     rshort

fieldname init
        bid
        oshort
        move.l  #'FLDN',d6
rstr
        retstrg
        do      d6
        lea     rets(a4),a5
        bra     retstr

cycl    init
        move.l  #thp.ret<<16,(a1)+
        move.l  a2,(a1)+
        exg     a2,a1
        move.l  a3,-4(a1)
        long
        exg     a2,a1
        retstrg
        do      #'CYCL'
        move.l  rets-4(a4),a3
        move.l  rets(a4),d7
        bsr     update
        lea     rets+4(a4),a5
        bra     retstr

svst    move.l  #'SVST',d6
        bra.s   sfin
smrk    move.l  #'SMRK',d6
        bra.s   sfin
setirs  move.l  #'SIRS',d6
sfin    init
        bid
        short
        bra     exitdo

filedevice
        move.l  #'FDEV',d6
        bra.s   fnam2
filename move.l #'FNAM',d6
fnam2   init
        bid
        bra     rstr

next    move.l  #'FORW',d6
        bra.s   navi
prev    move.l  #'BCKW',d6
navi    init
        bid
        oshort1
        bra     exitdo

frst    move.l  #'FRST',d6
        bra.s   bfin
last    move.l  #'LAST',d6
        bra.s   bfin
dupl    move.l  #'DUPL',d6
        bra.s   bfin
cmrk    move.l  #'CMRK',d6
        bra.s   bfin
dele    move.l  #'DELE',d6
        bra.s   bfin
newrec  move.l  #'NEWR',d6
        bra.s   bfin
impl    move.l  #'IMPL',d6
        bra.s   bfin
iupd    move.l  #'IUPD',d6
        bra.s   bfin
iimp    move.l  #'IIMP',d6
        bra.s   bfin
unus    move.l  #'UNUS',d6
        bra.s   bfin
irmv    move.l  #'IRMV',d6
        bra.s   bfin
savr    move.l  #'SAVR',d6
        bra.s   bfin
savf    move.l  #'SAVF',d6
        bra.s   bfin
idel    move.l  #'IDEL',d6
        bra.s   bfin
garb    move.l  #'GARB',d6
bfin    init
        bid
        bra     exitdo

defi    move.l  #'DEFI',d6
        bra.s   lex
grec    move.l  #'GREC',d6
lex     init
        bid
lng
        long
        bra     exitdo

gfld init
        bid
        field
        short
        clr.l   (a1)+
        long
        move.l  #'GFLD',d6
        bra     rlong

sfld init
        bid
        field
        short
        clr.l   (a1)+
        move.l  #'SFLD',d6
        bra     lng

defb init
        move.l  #'DEFB',d6
        bra     lng

fldd    move.l  #'FLDD',d6
        bra.s   fexit
deff    move.l  #'DEFF',d6
fexit  init
        bid
        field
        bra     exitdo

cycf init
        bid
        move.l  a3,(a2)+
        ushort
        ushort
        retstrg
        do      #'CYCF'
        move.l  rets(a4),a3
        move.l  rets+4(a4),d7
        bsr     update
        addq.l  #8,a3
        move.l  rets+8(a4),d7
        bsr     update
        lea     rets+12(a4),a5
        bra     retstr

gisl init
        bid
        short
        move.l  a3,(a2)+
        ushort
        ushort
        ushort
        do      #'GISL'
        move.l  rets(a4),a3
        move.l  rets+4(a4),d7
        ext.l   d7
        bsr     update
        addq.l  #8,a3
        move.l  rets+8(a4),d7
        bsr     update
        addq.l  #8,a3
        move.l  rets+12(a4),d7
        bsr     update
        exit

sisl init
        bid
        short
        move.w  #thp.upd+thp.uwrd,(a1)+
        clr.w   (a1)+
        addq.l  #2,a2
        move.l  a2,(a1)+
        subq.l  #2,a2
        exg     a1,a2
        bsr     get_cmp
        exg     a1,a2
        ushort
        ushort
        move.l  #'SISL',d6
        bra     exitdo

gifl init
        bid
        short
        move.l  a3,(a2)+
        ushort
        ushort
        ushort
        move.w  #thp.ret,(a1)+
        clr.w   (a1)+
        long
        do      #'GIFL'
        move.l  rets(a4),a3
        move.l  rets+4(a4),d7
        ext.l   d7
        bsr     update
        addq.l  #8,a3
        move.l  rets+8(a4),d7
        bsr     update
        addq.l  #8,a3
        move.l  rets+12(a4),d7
        bsr     update
        exit

sifl init
        bid
        short
        move.w  #thp.upd+thp.uwrd,(a1)+
        clr.w   (a1)+
        addq.l  #2,a2
        move.l  a2,(a1)+
        subq.l  #2,a2
        exg     a1,a2
        bsr     get_cmp
        exg     a1,a2
        ushort
        ushort
        move.w  #thp.ret,(a1)+
        clr.w   (a1)+
        long
        move.l  #'SIFL',d6
        bra     exitdo

idbf init
        move.l  #'IDBF',d6
        bra     rlong

save    move.l  #'SAVE',d6
        bra.s   save_
isav    move.l  #'ISAV',d6
        bra.s   save_
savi    move.l  #'SAVI',d6
        bra.s   save_
back    move.l  #'BACK',d6
save_   init
        bid
        string
        string
        oshort0
        bra     exitdo

iloa init
        bid
        string
        string
        retlong
        move.l  #'ILOA',d6
        bra     exitdo

use init
        bid
        string
        string
        oshort0
        retlong
        move.l  #'USE ',d6
        bra     exitdo

sshr init
        bid
        short
        move.l  #'SSHR',d6
oshf1
        field
        ; now we have to exchange the value and the field
        move.l  -4(a1),d7
        move.l  -8(a1),-4(a1)
        move.l  d7,-8(a1)
osh1
        oshort1
        bra     exitdo

slng init
        bid
        long
        move.l  #'SLNG',d6
        bra     oshf1

schr init
        bid
        char
        move.l  #'SCHR',d6
        bra     oshf1

sfloat init
        bid
        qldbl
        move.l  #'SDBL',d6
        bra.s   oshf2

sdbl init
        bid
        double
        move.l  #'SDBL',d6
oshf2
        field
        ; now we have to exchange the value and the field
        move.l  -4(a1),d7
        move.l  -8(a1),-4(a1)
        move.l  -12(a1),-8(a1)
        move.l  d7,-12(a1)
        bra     osh1

sstr init
        bid
        string
        move.l  #'SSTR',d6
        bra     oshf2

gchr init
        bid
        field
        oshort1
        ; prepare return string which has to be filled with a char
        move.w  #thp.ret+thp.char,(a1)+
        clr.w   (a1)+
        move.w  #1,(a2)+
        move.l  a2,(a1)+
        clr.w   (a2)+
        do      #'GCHR'
        lea     rets(a4),a5
        bra     retstr

gshr init
        bid
        field
        oshort1
        move.l  #'GSHR',d6
        bra     rshort

glng init
        bid
        field
        oshort1
        move.l  #'GLNG',d6
        bra     rlong

gdbl init
        bid
        field
        oshort1
        clr.l   (a1)+
        move.l  #'GDBL',d6
        bra     lng

gstr init
        bid
        field
        oshort1
        move.l  #'GSTR',d6
        bra     rstr

gfloat init
        bid
        field
        oshort1
        retdbl
        do      #'GDBL'
        lea     rets(a4),a5
        retfloat

sfst init
        bid
        short
        string
        string
        move.l  #'SFST',d6
        bra     exitdo

lenf    move.l  #'LENF',d6
        bra.s   lfret
nrln    move.l  #'NRLN',d6
lfret   init
        bid
        field
        bra     rlong

lens init
        bid
        field
        oshort1
        move.l  #'LENS',d6
        bra     rlong

gmrk init
        bid
        move.w  #thp.ret+thp.ubyt,(a1)+
        clr.w   (a1)+
        move.l  a2,(a1)+
        clr.w   (a2)+
        do      #'GMRK'
        moveq   #0,d7
        move.b  rets(a4),d7
        return

sort init
        bid
        compare
        short
        oshort1
        moveq   #8,d7
sortl   cmpa.l  a3,a5           ; have we had all parameters
        bne.s   sortc
        move.l  #-1,(a1)+
        bra.s   sorte
sortc   compare
        short
        oshort1
        dbf     d7,sortl
sorte   lea     $80(a4),a1
        lea     $88(a4),a2
        retlong
        move.l  #'SORT',d6
        bra     exitdo

rmve    move.l  #'RMVE',d6
        bra.s   rmve_
inse    move.l  #'INSE',d6
rmve_   init
        bid
        field
        oshort1
        oshort1
        bra     exitdo

fldr init
        bid
        field
        string
        move.l  #'FLDR',d6
        bra     exitdo

fldc init
        bid
        field
        oshort
        move.l  #'FLDC',d6
        bra     exitdo

        xref    ename
enam    lea     ename(pc),a1
        move.l  a1,d6
        bra.s   Xname
        xref    rname
rnam    lea     rname(pc),a1
        move.l  a1,d6
Xname   init
        bid                     ; SB chid in 4(a4)
        move.l  a3,(a1)+        ; place with string in 8(a4)
        string                  ; ptr to string in 16(a4) (ptr=rets(a4))
        ; we need a channel id, so get the passed one
        move.l  4(a4),d1        ; requested SB chid
        tst.l   (a4)            ; was one passed
        bne.s   chidng
        moveq   #1,d1           ; default SB chid
chidng  mulu    #ch.lench,d1    ; offset in list
        add.l   bv_chbas(a6),d1 ; place (rel with a6) whith channel id
        moveq   #err.ichn,d0    ; assume invalid chid
        cmp.l   bv_chp(a6),d1   ; SB chid not too high ??
        bge.s   EXname          ; oops
        move.l  0(a6,d1.l),d1   ; new chid
        bmi.s   EXname          ; oops, not valid channel id
        move.l  d1,a0           ; actual -valid- channel id

        ; now read/edit the string
        lea     rets(a4),a1     ; addr of string
        move.l  d6,a2
        jsr     (a2)            ; read/edit name
        bmi.s   ersserr
        moveq   #0,d0
        move.w  d1,d0           ; set terminating character as error
ersserr bsr     seterr          ; set the error in dd_err
        ; now update the value of the string (bp.let)
        lea     rets(a4),a3     ; string to set
        moveq   #3,d1           ; min len of string
        add.w   (a3),d1         ; + strlen
        andi.w  #$fffe,d1       ; make even
        move.l  d1,d4
        move.w  bv.chrix,a0
        jsr     (a0)            ; bv.chrix, reserve space on arithmetic stack
        move.l  bv_rip(a6),a1   ; offset of arithmetic stack
        sub.l   d4,a1
        move.l  a1,bv_rip(a6)   ; new offset of arithmetic stack
        move.w  (a3)+,d2
        move.w  d2,0(a1,a6.l)   ; strlen
        subq.w  #1,d2
        bmi.s   enamns
enamlp  move.b  (a3)+,2(a1,a6.l)
        addq.l  #1,a1
        dbf     d2,enamlp
enamns  move.l  8(a4),a3        ; name table entry to update
        move.l  bv_rip(a6),a1   ; place with string rel a6
        move.w  bi.sprm,a2
        jsr     (a2)            ; set new value of passed string
        moveq   #0,d0
doexit  exit
EXname  bsr     seterr
        exit

ifnd init
        bid
        move.l  (a4),blen-48(a4)
        move.l  4(a4),blen-44(a4)
        move.l  #1,blen-40(a4)
        move.l  #thp.ret<<16,-36(a4)
        move.l  #thp.ret<<16,-28(a4)
        move.l  #thp.ret<<16,-20(a4)
        lea     blen-12(a4),a1
        move.l  a1,blen-32(a4)
        clr.l   (a1)+
        move.l  a1,blen-24(a4)
        clr.l   (a1)+
        move.l  a1,blen-16(a4)
**        do      #'GISL'         ; get field for first sort level
        move.l  #'GISL',d2       ; name of extension to use
        jsr     dde_use(pc)     ; use thing
        bne     exit            ; you're kidding
        move.l  a1,a0           ; copy ptr to thing
        lea     blen-48(a4),a1  ; ptr to parameters
        jsr     thh_code(a0)    ; execute thing
        move.l  d0,d7
        bsr     seterr          ; set dd_err to the error code
        jsr     dde_free(pc)    ; free_thing            **
        tst.l   d7              ; was there an error
        bne.s   Eifnd
        moveq   #0,d1
        move.w  blen-8(a4),d1   ; fieldnr
        move.l  d1,blen-40(a4)
        lea     blen-4(a4),a1
        move.l  a1,blen-32(a4)  ; place for return fieldtype
**        do      #'FLDT'         ; get field type
        move.l  #'FLDT',d2       ; name of extension to use
        jsr     dde_use(pc)     ; use thing
        bne     exit            ; you're kidding
        move.l  a1,a0           ; copy ptr to thing
        lea     blen-48(a4),a1  ; ptr to parameters
        jsr     thh_code(a0)    ; execute thing
        move.l  d0,d7
        bsr     seterr          ; set dd_err to the error code
        jsr     dde_free(pc)    ; free_thing            **
        tst.l   d7              ; was there an error
        bne.s   Eifnd
        move.w  blen-4(a4),d1   ; fieldtype
        lea     8(a4),a1        ; place for rest of data
        move.l  #'IFND',d6
        cmpi.b  #2,d1
        beq.s   findchar
        cmpi.b  #3,d1
        beq.s   findword
        cmpi.b  #4,d1
        beq.s   findlong
        cmpi.b  #5,d1
        bne.s   Eifnd           ; oops, not a valid fieldtype
        qldbl
        bra     rlong
Eifnd   moveq   #-1,d7          ; not found
        return
findchar
        move.w  blen-12(a4),d1  ; compare "as text" ??
        btst    #c..text,d1
        bne.s   findtext
        char
        move.w  -2(a1),-4(a1)
        clr.w   -2(a1)
        clr.l   (a1)+
        bra     rlong
findword
        short
        move.w  -2(a1),-4(a1)
        clr.w   -2(a1)
        clr.l   (a1)+
        bra     rlong
findlong
        long
        clr.l   (a1)+
        bra     rlong
findtext
        bsr     get_txt8
        bra     rlong

filt init
        bid
        compare
        short
        oshort1
        bsr.s   filt8
        moveq   #8,d7
filtl   cmpa.l  a3,a5           ; have we had all parameters
        bne.s   filtc
        move.l  #-1,(a1)+
        bra.s   filte
filtc   move.w  d7,blen+4(a4)
        compare
        short
        oshort1
        bsr.s   filt8
        move.w  blen+4(a4),d7
        dbf     d7,filtl
filte   lea     $d0(a4),a1
        lea     $d8(a4),a2
        retlong
        move.l  #'FILT',d6
        bra     exitdo

filt8   ; read parameter according to fieldtype
        move.l  a3,-(sp)        ; keep it just in case or error
        move.l  a1,a3           ; place for fielddata
        move.l  (a4),blen-48(a4)
        move.l  4(a4),blen-44(a4)
        moveq   #0,d1
        move.w  -6(a1),d1       ; fieldid
        move.l  d1,blen-40(a4)
        lea     blen-12(a4),a1
        move.l  a1,blen-32(a4)  ; place for return fieldtype
**        do      #'FLDT'         ; get field type
        move.l  #'FLDT',d2       ; name of extension to use
        jsr     dde_use(pc)     ; use thing
        bne     exit            ; you're kidding
        move.l  a1,a0           ; copy ptr to thing
        lea     blen-48(a4),a1  ; ptr to parameters
        jsr     thh_code(a0)    ; execute thing
        move.l  d0,d7
        bsr     seterr          ; set dd_err to the error code
        jsr     dde_free(pc)    ; free_thing            **
        tst.l   d7              ; was there an error
        bne.s   Efilt8
        move.w  blen-12(a4),d1  ; fieldtype
        move.l  a3,a1
        move.l  (sp)+,a3
        cmpi.b  #2,d1
        beq.s   filtchar
        cmpi.b  #3,d1
        beq.s   filtword
        cmpi.b  #4,d1
        beq.s   filtlong
        cmpi.b  #5,d1
        bne     doexit          ; oops, not a valid fieldtype
        qldbl
        rts
filtchar
        bra     get_txt8
filtword
        short
        move.w  -2(a1),-4(a1)
        clr.w   -2(a1)
        clr.l   (a1)+
        rts
filtlong
        long
        clr.l   (a1)+
        rts
Efilt8  move.l  a3,a1
        clr.l   (a1)+
        clr.l   (a1)+
        move.l  (sp)+,a3
        rts

fndd init
        bid
        field
        compare
        qldbl
        move.l  #'FNDD',d6
find    lea     rets(a4),a2
        move.l  a3,(a2)+
        move.l  a5,(a2)+
;        ushort         ; has to be for an optional variable
        move.l  #thp.upd+thp.uwrd<<16,(a1)+
        addq.l  #2,a2
        move.l  a2,(a1)+
        subq.l  #2,a2
        exg     a1,a2
        bsr     get_oi
        exg     a1,a2
;        ushort
        move.l  #thp.upd+thp.uwrd<<16,(a1)+
        addq.l  #2,a2
        move.l  a2,(a1)+
        subq.l  #2,a2
        exg     a1,a2
        bsr     get_oi
        exg     a1,a2
        do      d6
        move.l  rets(a4),a3
        move.l  rets+4(a4),a5
        cmpa.l  a3,a5
        beq.s   findd
        move.l  rets+8(a4),d7
        bsr     update
        addq.l  #8,a3
        cmpa.l  a3,a5
        beq.s   findd
        move.l  rets+12(a4),d7
        bsr     update
findd
        exit

fndi init
        bid
        field
        compare
        short
        clr.l   (a1)+
        move.l  #'FNDI',d6
        bra     find

fnds init
        bid
        field
        compare
        lea     rets+40(a4),a2
        string
        move.l  #'FNDS',d6
        bra     find
;
        end
